Vue UI Components Documentation

Vue Chart Component

The Chart component for Vue represents a lightweight and powerful chart widget. It offers many advanced features and supports three different rendering technologies - SVG, HTML5 Canvas & VML.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Chart component for Vue requires the following import:

import JqxChart from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxchart.vue';

Add the jqxChart component to the components section of the the Vue class:

 components: {
JqxChart
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxChart/>

<template>
<JqxChart style="width: 850px; height: 500px"
:title="'Fitness & exercise weekly scorecard'"
:description="'Time spent in vigorous exercise'"
:showToolTip="false" :enableAnimations="true" :padding="padding"
:titlePadding="titlePadding" :source="sampleData" :xAxis="xAxis"
:seriesGroups="seriesGroups" :colorScheme="'scheme04'">
</JqxChart>
</template>

Properties

The properties of the <JqxChart/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
sampleData: [
{ Day: 'Monday', Keith: 30, Erica: 15, George: 25 },
{ Day: 'Tuesday', Keith: 25, Erica: 25, George: 30 },
{ Day: 'Wednesday', Keith: 30, Erica: 20, George: 25 },
{ Day: 'Thursday', Keith: 35, Erica: 25, George: 45 },
{ Day: 'Friday', Keith: 20, Erica: 20, George: 25 },
{ Day: 'Saturday', Keith: 30, Erica: 20, George: 30 },
{ Day: 'Sunday', Keith: 60, Erica: 45, George: 90 }
],
padding: { left: 5, top: 5, right: 5, bottom: 5 },
titlePadding: { left: 90, top: 0, right: 0, bottom: 10 },
xAxis: {
dataField: 'Day',
type: 'basic'
},
seriesGroups: [
{
type: 'column',
valueAxis:
{
minValue: 0,
maxValue: 100,
unitInterval: 10,
title: { text: 'Time in minutes' }
},
series: [
{ dataField: 'Keith', displayText: 'Keith' },
{ dataField: 'Erica', displayText: 'Erica' },
{ dataField: 'George', displayText: 'George' }
]
}
]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxChart style="width: 850px; height: 500px"
@click="onChartClick()"
:title="'U.S. Stock Market Index Performance'"
:description="'NASDAQ Composite compared to S&P 500'"
:showLegend="true" :enableAnimations="true" :padding="padding"
:titlePadding="titlePadding" :source="dataAdapter" :xAxis="xAxis"
:valueAxis="valueAxis" :seriesGroups="seriesGroups" :colorScheme="'scheme04'">
</JqxChart>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onChartClick: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxChart ref="chart"></JqxChart>

Here how you can use a component's method:

this.$refs.chart.refresh();

methods: {
// Add here all used callbacks and/or events
onChartClick: function () {
// Do something when clicking on the chart
this.$refs.chart.refresh();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxChart style="width: 850px; height: 500px"
ref="chart" @click="onChartClick()"
:title="'Fitness & exercise weekly scorecard'"
:description="'Time spent in vigorous exercise'"
:showToolTip="false" :enableAnimations="true" :padding="padding"
:titlePadding="titlePadding" :source="sampleData" :xAxis="xAxis"
:seriesGroups="seriesGroups" :colorScheme="'scheme04'">
</JqxChart>
</template>
<script>
// Import the components that will be used
import JqxChart from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxchart.vue';
export default {
components: {
// Adding imported widgets here
JqxChart
},
data: function () {
// Define properties which will use in the widget
return {
sampleData: [
{ Day: 'Monday', Keith: 30, Erica: 15, George: 25 },
{ Day: 'Tuesday', Keith: 25, Erica: 25, George: 30 },
{ Day: 'Wednesday', Keith: 30, Erica: 20, George: 25 },
{ Day: 'Thursday', Keith: 35, Erica: 25, George: 45 },
{ Day: 'Friday', Keith: 20, Erica: 20, George: 25 },
{ Day: 'Saturday', Keith: 30, Erica: 20, George: 30 },
{ Day: 'Sunday', Keith: 60, Erica: 45, George: 90 }
],
padding: { left: 5, top: 5, right: 5, bottom: 5 },
titlePadding: { left: 90, top: 0, right: 0, bottom: 10 },
xAxis: {
dataField: 'Day',
type: 'basic'
},
seriesGroups: [
{
type: 'column',
valueAxis:
{
minValue: 0,
maxValue: 100,
unitInterval: 10,
title: { text: 'Time in minutes' }
},
series: [
{ dataField: 'Keith', displayText: 'Keith' },
{ dataField: 'Erica', displayText: 'Erica' },
{ dataField: 'George', displayText: 'George' }
]
}
]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onChartClick: function () {
// Do something when clicking on the chart
this.$refs.chart.refresh();
}
}
}
</script>
<style>
</style>

Chart Example

<template>
<JqxChart style="width: 850px; height: 500px"
:title="'Economic comparison'"
:description="'GDP and Debt in 2010'"
:showLegend="true" :enableAnimations="true" :padding="padding"
:titlePadding="titlePadding" :source="dataAdapter" :xAxis="xAxis"
:columnSeriesOverlap="false" :seriesGroups="seriesGroups" :colorScheme="'scheme01'">
</JqxChart>
</template>
<script>
import JqxChart from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxchart.vue';
export default {
components: {
JqxChart
},
data: function () {
return {
dataAdapter: new jqx.dataAdapter(this.source, { async: false, autoBind: true, loadError: (xhr, status, error) => { alert('Error loading "' + this.source.url + '" : ' + error); } }),
padding: { left: 5, top: 5, right: 5, bottom: 5 },
titlePadding: { left: 90, top: 0, right: 0, bottom: 10 },
xAxis: {
dataField: 'Country',
gridLines: { visible: true },
valuesOnTicks: false
},
seriesGroups: [
{
type: 'column',
valueAxis:
{
visible: true,
unitInterval: 5000,
title: { text: 'GDP & Debt per Capita($)<br>' }
},
series: [
{ dataField: 'GDP', displayText: 'GDP per Capita' },
{ dataField: 'Debt', displayText: 'Debt per Capita' }
]
},
{
type: 'line',
valueAxis:
{
visible: true,
position: 'right',
unitInterval: 10,
title: { text: 'Debt (% of GDP)' },
gridLines: { visible: false },
labels: { horizontalAlignment: 'left' }
},
series: [
{ dataField: 'DebtPercent', displayText: 'Debt (% of GDP)' }
]
}
]
}
},
beforeCreate: function () {
this.source =
{
datatype: 'csv',
datafields: [
{ name: 'Country' },
{ name: 'GDP' },
{ name: 'DebtPercent' },
{ name: 'Debt' }
],
url: 'sampledata/gdp_dept_2010.txt'
};
}
}
</script>
<style>
</style>

Run Code

Angular UI Components Documentation

Angular Chart Component

The Chart component for Angular represents a lightweight and powerful chart widget. It offers many advanced features and supports three different rendering technologies - SVG, HTML5 Canvas & VML.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxChart #myChart
    [width]="getWidth()" [height]="500"
    [title]="'U.S. Stock Market Index Performance'"
    [description]="'NASDAQ Composite compared to S&P 500'"
    [showLegend]="true" [enableAnimations]="true" [padding]="padding"
    [titlePadding]="titlePadding" [source]="dataAdapter" [xAxis]="xAxis"
    [valueAxis]="valueAxis" [seriesGroups]="seriesGroups" [colorScheme]="'scheme04'">
</jqxChart>	

3. Setup Component Logic

app.component.ts


import { Component } from '@angular/core';

import { jqxChartModule, jqxChartComponent } from 'jqwidgets-ng/jqxchart';
@Component({
    selector: 'app-root',
    imports: [jqxChartModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent {
    months: string[] = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

    source: any =
        {
            datatype: "csv",
            datafields: [
                { name: 'Date' },
                { name: 'S&P 500' },
                { name: 'NASDAQ' }
            ],
            url: '../assets/nasdaq_vs_sp500.txt'
        };

    dataAdapter: any = new jqx.dataAdapter(this.source, { async: false, autoBind: true, loadError: (xhr: any, status: any, error: any) => { alert('Error loading "' + this.source.url + '" : ' + error); } });

    padding: any = { left: 10, top: 5, right: 10, bottom: 5 };

    titlePadding: any = { left: 50, top: 0, right: 0, bottom: 10 };

    getWidth(): any {
        if (document.body.offsetWidth < 850) {
            return '90%';
        }

        return 850;
    }

    xAxis: any =
        {
            dataField: 'Date',
            formatFunction: (value: any) => {
                return value.getDate() + '-' + this.months[value.getMonth()] + '-' + value.getFullYear();
            },
            type: 'date',
            baseUnit: 'month',
            valuesOnTicks: true,
            minValue: '01-01-2014',
            maxValue: '01-01-2015',
            tickMarks: {
                visible: true,
                interval: 1,
                color: '#BCBCBC'
            },
            unitInterval: 1,
            gridLines: {
                visible: true,
                interval: 3,
                color: '#BCBCBC'
            },
            labels: {
                angle: -45,
                rotationPoint: 'topright',
                offset: { x: 0, y: -25 }
            }
        };

    valueAxis: any =
        {
            visible: true,
            title: { text: 'Daily Closing Price<br>' },
            tickMarks: { color: '#BCBCBC' }
        };

    seriesGroups: any =
        [
            {
                type: 'line',
                series: [
                    { dataField: 'S&P 500', displayText: 'S&P 500' },
                    { dataField: 'NASDAQ', displayText: 'NASDAQ' }
                ]
            }
        ];
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Chart API

API Reference of the jQWidgets Chart component for Angular: Chart API

React UI Components Documentation

ReactJS Chart Component

The Chart component for ReactJS represents a lightweight and powerful chart widget. It offers many advanced features and supports three different rendering technologies - SVG, HTML5 Canvas & VML.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The Chart component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxChart from 'jqwidgets-react/react_jqxchart.js';

Then we create our component class. Properties and methods are put as ReactJS props.

  
class App extends React.Component {
render () {
return (
<JqxChart
style={{ width: 850, height: 500 }}
showLegend={true} enableAnimations={true}
source={dataAdapter} xAxis={xAxis}
valueAxis={valueAxis} seriesGroups={seriesGroups}
/>
)
}
}

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxChart ref='myChart' style={{ width: 850, height: 500 }}..... />

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

 
class App extends React.Component {
componentDidMount()
{
//your logic
}
render ()
{
return
(
....
)
}
};

Events

The click event is raised when the user clicks on series element.

The following example demonstrates how to add an event listener.

 
componentDidMount ()
{
this.refs.myChart.on('click', (event) =>
{
//your logic
});
}

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

 
this.refs.myChart.setOptions({
colorScheme: 'scheme07',
showLegend: 'true',
xAxis: {
gridLines: { visible: false }
}
})

Every component also have a method getOptions which returns a object containing the component settings.

 
let options = this.refs.myChart.getOptions();

Chart Examples

Overview

The following example demonstrates how to create a Chart component.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxChart from 'jqwidgets-react/react_jqxchart.js';
class App extends React.Component {
render () {
let source =
{
datatype: "csv",
datafields: [
{ name: 'Date' },
{ name: 'S&P 500' },
{ name: 'NASDAQ' }
],
url: 'sampledata/nasdaq_vs_sp500.txt'
};
let dataAdapter = new $.jqx.dataAdapter(source, { async: false, autoBind: true, loadError: (xhr, status, error) => { alert('Error loading "' + source.url + '" : ' + error); } });
let months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
let padding = { left: 10, top: 5, right: 10, bottom: 5 };
let titlePadding = { left: 50, top: 0, right: 0, bottom: 10 };
let xAxis =
{
dataField: 'Date',
formatFunction: function (value) {
return value.getDate() + '-' + months[value.getMonth()] + '-' + value.getFullYear();
},
type: 'date',
baseUnit: 'month',
valuesOnTicks: true,
minValue: '01-01-2014',
maxValue: '01-01-2015',
tickMarks: {
visible: true,
interval: 1,
color: '#BCBCBC'
},
unitInterval: 1,
gridLines: {
visible: true,
interval: 3,
color: '#BCBCBC'
},
labels: {
angle: -45,
rotationPoint: 'topright',
offset: { x: 0, y: -25 }
}
};
let valueAxis =
{
visible: true,
title: { text: 'Daily Closing Price<br>' },
tickMarks: { color: '#BCBCBC' }
};
let seriesGroups =
[
{
type: 'line',
series: [
{ dataField: 'S&P 500', displayText: 'S&P 500' },
{ dataField: 'NASDAQ', displayText: 'NASDAQ' }
]
}
];
return (
<JqxChart
style={{ width:850, height:500 }}
title={"U.S. Stock Market Index Performance"} description={"NASDAQ Composite compared to S&P 500"}
showLegend={true} enableAnimations={true} padding={padding}
titlePadding={titlePadding} source={dataAdapter} xAxis={xAxis}
valueAxis={valueAxis} colorScheme={'scheme04'} seriesGroups={seriesGroups}
/>
)
}
}
ReactDOM.render(<App />, document.getElementById('app'));

Set Chart Columns with Local Data

The following example demonstrates the Chart bind to Local Data.

Donut Series

The following example demonstrates how to create a Chart component for ReactJS with two series of donut type (one inner and another one outer).

Chart API

API Reference of the jQWidgets Chart component for React: Chart API